import java.awt.Frame;
import java.awt.BorderLayout;
import controlP5.*;

private ControlP5 cp5;
float threshold;
float inkval[];
float ink0, ink1, ink2, ink3, ink4, ink5, ink6, ink7, ink8, ink9, ink10, ink11;
int NUM;
String [][] data;
String [] dsname;
//  int LENGTH;
int valueR, valueG, valueB;
int paraNUM, useNUM, useeNUM;

//boolean booleanBC;
boolean saves;
color cw;
color [] cold;
color[] dccolor;
PImage img;
PImage th_img;

Bin bin;
ControlFrame cf;
DropdownList[] dl;



void setup () {
  NUM = 4;
  paraNUM = 12;
  useNUM = 8;
  cold = new color[paraNUM];
  inkval = new float[12];


  for (int i = 4; i< cold.length; i++) {
    cold[i] = color(255);
  }

  //// Load Color CSV
  String file[] = loadStrings("test.csv");

  data = new String[file.length][NUM];
  for (int i=0; i < file.length; i++) {
    String [] tmp = split(file[i], ",");
    for (int j=0; j < tmp.length; j++) {
      data[i][j] = tmp[j];
    }
  }

  dccolor = new color[file.length];

  for (int i = 0; i < file.length; i++) {
    dccolor[i] = color(Integer.parseInt(data[i][1]), Integer.parseInt(data[i][2]), Integer.parseInt(data[i][3]));
  }

  dsname = loadStrings("colorname.csv");

  selectInput("Select a File", "fileSelected");
  noLoop();
  interrupt();
  if (img.width > 1000 || img.height > 900) {
    size(img.width/3, img.height/3);
  }
  else {
    size(img.width, img.height);
  }
  background(0);
  saves = false;

  bin = new Bin(img);



  cp5 = new ControlP5(this);
  //// for disoplaying controller on subwindow
  cf = addControlFrame("controlP5window", 500, 800);

  //// Input Color 


  cw = color(255, 255, 255);
  cold[0] = color(200, 200, 200);
  cold[1] = color(150, 150, 150);
  cold[2] = color(100, 100, 100);
  cold[3] = color(0, 0, 0);
}

/*
  Controller toggleBC = controlP5.addToggle("toggleBC", false, 50, 30, 20, 20);
 toggleBC.setWindow(controlWindow);
 
 Controller bangEXP  = controlP5.addBang("bangEXP", 20, 30, 20, 20);
 bangEXP.setWindow(controlWindow);
 */

//// JPG File Selection
void fileSelected(File selection) {
  img = loadImage(selection.getAbsolutePath());
  MedFilClass med = new MedFilClass(img);
  PImage med_img = med.process();
  img = med_img;
}

void interrupt() {
  while (img == null) {
    delay(200);
  }
  loop();
}


void draw()
{
  background(255);
  PImage sdf_img = bin.RGBbin();
  th_img = sdf_img;

  if (img.width > 1000 || img.height > 900) {
    image(th_img, 0, 0, img.width/3, img.height/3);
  } 
  else {
    image(th_img, 0, 0);
  }
}


ControlFrame addControlFrame(String theName, int theWidth, int theHeight) {
  Frame f = new Frame(theName);
  ControlFrame p = new ControlFrame(this, theWidth, theHeight);
  f.add(p);
  p.init();
  f.setTitle(theName);
  f.setSize(p.w, p.h);
  f.setLocation(100, 100);
  f.setResizable(false);
  f.setVisible(true);
  return p;
}


